/**
 * $Id: types.h,v 1.2 2002/10/08 15:01:45 plasmahh Exp $
 * $Revision: 1.2 $
 * $Author: plasmahh $
 * $Date: 2002/10/08 15:01:45 $
 */

/**
 * This file makes some definitions of the standard types.
 * This is because some architectures implement some things differentely.
 */

#ifndef __TYPES_H
#define __TYPES_H

#ifdef __linux__
typedef bool		BOOL;
typedef float 		double32;
typedef double 		double64;

typedef signed long 	sint32;
typedef	unsigned long	uint32;
typedef signed long long sint64;
typedef unsigned long long uint64;

typedef	unsigned char	byte8;
typedef signed char	schar8;
typedef unsigned char	uchar8;

typedef signed short	sint16;
typedef unsigned short	uint16;
#endif // __linux__

#ifdef __sparc__
typedef bool            BOOL;

typedef float           double32;
typedef double          double64;

typedef signed long     sint32;
typedef unsigned long   uint32;
typedef signed long long sint64;
typedef unsigned long long uint64;

typedef unsigned char   byte8;
typedef signed char     schar8;
typedef unsigned char   uchar8;

typedef signed short    sint16;
typedef unsigned short  uint16;
#endif // __sparc__

#else
#warning multiple inclusion of types.h please check !
#endif
/**
 *$Log: types.h,v $
 *Revision 1.2  2002/10/08 15:01:45  plasmahh
 *some changes for compatibility with sun/solaris/sparc
 *
 *Revision 1.1  2002/10/01 21:07:27  plasmahh
 *new math stuff
 *
 *Revision 1.1  2002/06/10 10:36:07  plasmahh
 *Added some math classes in design state, not to be compiled
 *
 */
